## qdmr 0.13.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20.0)
project(qdmr VERSION 0.13.1)

set(RELEASE_SUFFIX "")

cmake_policy(SET CMP0100 NEW)
cmake_policy(SET CMP0140 NEW)

set(CMAKE_C_STANDARD 99)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)


set(DOCBOOK2MAN_XSLT_DEFAULT "docbook_man.debian.xsl")
if(UNIX AND APPLE)
  set(DOCBOOK2MAN_XSLT_DEFAULT "docbook_man.macports.xsl")
endif(UNIX AND APPLE)

option(BUILD_TESTS "Build test programs" OFF)
option(BUILD_DOCS  "Build API documentation" OFF)
option(BUILD_MAN   "Build man page for dmrconf" OFF)
option(INSTALL_UDEV_RULES "Install udev rules file." ON)
option(INSTALL_UDEV_PATH "Install path of udev rules file." "/etc/udev/rules.d")
option(INSTALL_APPSTREAM_DATA "Install AppStream metainfo file." ON)
option(INSTALL_BUNDLE "Installs QDMR as an AppBundle under MacOS X" OFF)
option(BUNDLE_PATH "Where to install the MacOS X application bundle." "~/Applications")
option(DOCBOOK2MAN_XSLT "Man page style sheet." ${DOCBOOK2MAN_XSLT_DEFAULT})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

include(GNUInstallDirs)
include(GenerateIcons)

find_package(Qt6 REQUIRED COMPONENTS Core Widgets UiTools Network SerialPort Positioning LinguistTools)
qt6_standard_project_setup()

find_package(LIBUSB_1 REQUIRED)
find_package(YAMLCPP REQUIRED)
find_program(CONVERT_CMD rsvg-convert DOC "SVG conversion tool (librsvg)." REQUIRED)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(USE_FOLDERS ON)


if (BUILD_MAN)
  find_program(XSLTPROC_EXECUTABLE NAMES xsltproc)
endif()

if (BUILD_DOCS)
  find_package(Doxygen REQUIRED dot)
endif()

if (${BUILD_TESTS})
  find_package(Qt6 REQUIRED COMPONENTS Test)
endif(${BUILD_TESTS})

IF (UNIX AND APPLE)
  SET(ADDITIONAL_LIBS ${ADDITIONAL_LIBS} "-framework IOKit -framework CoreFoundation")
ENDIF(UNIX AND APPLE)

INCLUDE_DIRECTORIES(${LIBUSB_1_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${YAMLCPP_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/src)
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/lib)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/lib)

LINK_DIRECTORIES(${PROJECT_BINARY_DIR}/src)


set(PROJECT_VERSION_STRING "\"${PROJECT_VERSION}\"")
message(STATUS "Build version ${PROJECT_VERSION}")

# Set compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wsign-compare")
set(CMAKE_CXX_FLAGS_DEBUG   "${CMAKE_CXX_FLAGS_DEBUG}  -O0 -ggdb -fstack-protector -Wextra")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -Wextra")


# Get default install directories under Linux
IF(UNIX AND NOT APPLE)
 INCLUDE(GNUInstallDirs)
ENDIF(UNIX AND NOT APPLE)
IF(UNIX AND APPLE)
 SET(CMAKE_INSTALL_LIBDIR "lib")
 SET(CMAKE_INSTALL_FULL_LIBDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
 SET(CMAKE_INSTALL_INCLUDEDIR "include")
 SET(CMAKE_INSTALL_FULL_INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}")
 # Set RPATH under MacOS
 SET(CMAKE_SKIP_RPATH FALSE)
 SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
 SET(CMAKE_SKIP_INSTALL_RPATH FALSE)
 SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
 SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
 SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
 message(STATUS "RPATH: ${CMAKE_INSTALL_RPATH}")
ENDIF(UNIX AND APPLE)


# Sources...
add_subdirectory(lib)
add_subdirectory(cli)
add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(dist)

if(BUILD_TESTS)
 enable_testing()
 add_subdirectory(test)
endif(BUILD_TESTS)

# Source distribution packages:
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME
  "${CMAKE_PROJECT_NAME}-${PROJECT_VERSION}${RELEASE_SUFFIX}")
set(CPACK_SOURCE_IGNORE_FILES
  "/build/;/doc/html;/doc/latex;/doc/reveng;/doc/dmr-intro;/examples/*.dfu;/.git/;~$;.qm;*.user$;${CPACK_SOURCE_IGNORE_FILES}")

include(CPack)

=== cli/CMakeLists.txt ===
qt_add_executable(dmrconf WIN32
  main.cc
  printprogress.cc printprogress.hh
  detect.cc detect.hh
  verify.cc verify.hh
  readcodeplug.cc readcodeplug.hh
  writecodeplug.cc writecodeplug.hh
  encodecodeplug.cc encodecodeplug.hh
  decodecodeplug.cc decodecodeplug.hh
  infofile.cc infofile.hh
  writecallsigndb.cc writecallsigndb.hh
  encodecallsigndb.cc encodecallsigndb.hh
  progressbar.cc progressbar.hh
  autodetect.cc autodetect.hh)

target_link_libraries(
  dmrconf PRIVATE Qt6::Core Qt6::SerialPort Qt6::Network Qt6::Positioning
                  ${LIBUSB_1_LIBRARIES} ${YAMLCPP_LIBRARIES} libdmrconf)

install(TARGETS dmrconf DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})

=== dist/CMakeLists.txt ===
if (UNIX AND NOT APPLE)
  configure_file("qdmr.desktop.in" "qdmr.desktop")
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qdmr.desktop DESTINATION share/applications/)
  install(FILES ${PROJECT_SOURCE_DIR}/dist/qdmr32.png DESTINATION share/icons/hicolor/32x32/apps/ RENAME qdmr.png)
  install(FILES ${PROJECT_SOURCE_DIR}/dist/qdmr48.png DESTINATION share/icons/hicolor/48x48/apps/ RENAME qdmr.png)
  install(FILES ${PROJECT_SOURCE_DIR}/dist/qdmr64.png DESTINATION share/icons/hicolor/64x64/apps/ RENAME qdmr.png)
  install(FILES ${PROJECT_SOURCE_DIR}/dist/qdmr72.png DESTINATION share/icons/hicolor/72x72/apps/ RENAME qdmr.png)
  install(FILES ${PROJECT_SOURCE_DIR}/dist/qdmr96.png DESTINATION share/icons/hicolor/96x96/apps/ RENAME qdmr.png)
endif(UNIX AND NOT APPLE)

if (UNIX AND NOT APPLE AND ${INSTALL_APPSTREAM_DATA})
  install(FILES ${PROJECT_SOURCE_DIR}/dist/de.darc.dm3mat.qdmr.metainfo.xml DESTINATION share/metainfo/)
endif(UNIX AND NOT APPLE AND ${INSTALL_APPSTREAM_DATA})

=== doc/CMakeLists.txt ===
#
# man-page generation
#
message(STATUS "Using xsltproc: ${XSLTPROC_EXECUTABLE}")
configure_file("dmrconf.in.xml" "dmrconf.xml")
configure_file("qdmr.in.xml" "qdmr.xml")

add_custom_command(
  OUTPUT dmrconf.1
  COMMAND ${XSLTPROC_EXECUTABLE}
          -o ${CMAKE_CURRENT_BINARY_DIR}/dmrconf.1
          ${CMAKE_CURRENT_SOURCE_DIR}/${DOCBOOK2MAN_XSLT}
          ${CMAKE_CURRENT_BINARY_DIR}/dmrconf.xml
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/dmrconf.xml
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMENT "Generating man-page for dmrconf."
  VERBATIM)

add_custom_command(
  OUTPUT qdmr.1
  COMMAND ${XSLTPROC_EXECUTABLE}
          -o ${CMAKE_CURRENT_BINARY_DIR}/qdmr.1
          ${CMAKE_CURRENT_SOURCE_DIR}/${DOCBOOK2MAN_XSLT}
          ${CMAKE_CURRENT_BINARY_DIR}/qdmr.xml
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/qdmr.xml
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMENT "Generating man-page for qdmr."
  VERBATIM)

if (${BUILD_MAN})
  # Create man page from docbook
  add_custom_target(dmrconf_manpage ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/dmrconf.1)
  add_custom_target(qdmr_manpage ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/qdmr.1)
  # install man page on unix systems
  if (UNIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dmrconf.1
                  ${CMAKE_CURRENT_BINARY_DIR}/qdmr.1
      DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1/)
  endif (UNIX)
endif(${BUILD_MAN})

#
# optional API docs
#
if (${BUILD_DOCS})
  set(DOXYGEN_PROJECT_NAME "libdrmconf")
  set(DOXYGEN_PROJECT_BRIEF "A library to program DMR radios.")
  set(DOXYGEN_BRIEF_MEMBER_DESC YES)
  set(DOXYGEN_JAVADOC_AUTOBRIEF YES)
  set(DOXYGEN_EXAMPLE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/code")
  set(DOXYGEN_DOTFILE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/fig")
  set(DOXYGEN_ENABLE_PREPROCESSING YES)
  set(DOXYGEN_MACRO_EXPANSION YES)
  set(DOXYGEN_EXPAND_ONLY_PREDEF YES)
  set(DOXYGEN_PREDEFINED __attribute__(x) =)
  set(DOXYGEN_IMAGE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/fig")
  doxygen_add_docs(apidocs
    ALL
    ${CMAKE_SOURCE_DIR}/lib
    COMMENT "Build API documentation")
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
          DESTINATION ${CMAKE_INSTALL_DOCDIR}/libdmrconf/)
endif(${BUILD_DOCS})

=== i18n/Makefile ===
update:
	/usr/lib/qt6/bin/lupdate ../src/*.cc ../src/*.hh ../src/*.ui ../shared/ui/*.ui -noobsolete -ts *.ts

=== lib/CMakeLists.txt ===
IF (APPLE)
 SET(hid_SOURCES hid_macos.cc)
 SET(hid_HEADERS hid_macos.hh)
ELSE (APPLE)
 SET(hid_SOURCES hid_libusb.cc)
 SET(hid_HEADERS hid_libusb.hh)
ENDIF(APPLE)

configure_file(config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)

qt_add_library(libdmrconf SHARED
  ${hid_SOURCES}
  ${CMAKE_CURRENT_BINARY_DIR}/config.h
  utils.cc crc32.cc addressmap.cc radiointerface.cc errorstack.cc frequency.cc interval.cc
  ranges.cc dummyfilereader.cc chirpformat.cc signaling.cc radio.cc dfu_libusb.cc usbserial.cc
  radioinfo.cc usbdevice.cc radiolimits.cc csvreader.cc dfufile.cc userdatabase.cc logger.cc
  melody.cc visitor.cc configlabelingvisitor.cc configcopyvisitor.cc
  intermediaterepresentation.cc configmergevisitor.cc configobject.cc configreference.cc config.cc
  radiosettings.cc contact.cc rxgrouplist.cc channel.cc zone.cc scanlist.cc gpssystem.cc codeplug.cc
  roamingzone.cc roamingchannel.cc callsigndb.cc talkgroupdatabase.cc radioid.cc transferflags.cc
  encryptionextension.cc commercial_extension.cc smsextension.cc
  satellitedatabase.cc orbitalelementsdatabase.cc transponderdatabase.cc satelliteconfig.cc
  tyt_radio.cc tyt_interface.cc tyt_codeplug.cc tyt_callsigndb.cc tyt_extensions.cc
  md2017.cc md2017_codeplug.cc md2017_callsigndb.cc md2017_filereader.cc md2017_limits.cc
  md390.cc md390_codeplug.cc md390_filereader.cc md390_limits.cc
  uv390.cc uv390_codeplug.cc uv390_callsigndb.cc uv390_filereader.cc uv390_limits.cc
  dm1701.cc dm1701_codeplug.cc dm1701_callsigndb.cc dm1701_filereader.cc dm1701_limits.cc
  radioddity_radio.cc radioddity_codeplug.cc radioddity_extensions.cc radioddity_interface.cc
  rd5r.cc rd5r_codeplug.cc rd5r_filereader.cc rd5r_limits.cc
  gd77.cc gd77_codeplug.cc gd77_callsigndb.cc gd77_filereader.cc gd77_limits.cc
  opengd77_interface.cc opengd77base.cc opengd77base_codeplug.cc opengd77base_callsigndb.cc
  opengd77base_satelliteconfig.cc opengd77_extension.cc opengd77_limits.cc
  opengd77.cc opengd77_codeplug.cc opengd77_callsigndb.cc opengd77_satelliteconfig.cc
  openuv380.cc openuv380_codeplug.cc openuv380_callsigndb.cc openuv380_satelliteconfig.cc
  openrtx.cc openrtx_interface.cc openrtx_codeplug.cc
  c7000device.cc
  gd73.cc gd73_interface.cc gd73_codeplug.cc gd73_filereader.cc gd73_limits.cc
  anytone_interface.cc anytone_radio.cc anytone_codeplug.cc anytone_extension.cc anytone_limits.cc
  anytone_satelliteconfig.cc anytone_settingsextension.cc
  d868uv.cc d868uv_codeplug.cc d868uv_callsigndb.cc d868uv_limits.cc
  d878uv.cc d878uv_codeplug.cc d878uv_limits.cc
  d578uv.cc d578uv_codeplug.cc d578uv_limits.cc
  d878uv2.cc d878uv2_codeplug.cc d878uv2_limits.cc d878uv2_callsigndb.cc
  dmr6x2uv.cc dmr6x2uv_codeplug.cc dmr6x2uv_limits.cc
  dmr6x2uv2.cc dmr6x2uv2_codeplug.cc dmr6x2uv2_limits.cc
  auctus_a6_interface.cc
  dr1801uv.cc dr1801uv_interface.cc dr1801uv_codeplug.cc dr1801uv_filereader.cc dr1801uv_limits.cc)

target_sources(libdmrconf PUBLIC FILE_SET HEADERS
  BASE_DIRS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}
  FILES
  ${CMAKE_CURRENT_BINARY_DIR}/config.h
  libdmrconf.hh utils.hh ${hid_HEADERS} crc32.hh addressmap.hh radiointerface.hh errorstack.hh
  frequency.hh interval.hh ranges.hh dummyfilereader.hh chirpformat.hh signaling.hh radio.hh
  dfu_libusb.hh usbserial.hh radioinfo.hh usbdevice.hh radiolimits.hh csvreader.hh dfufile.hh
  userdatabase.hh logger.hh melody.hh visitor.hh configlabelingvisitor.hh configcopyvisitor.hh
  intermediaterepresentation.hh configmergevisitor.hh configobject.hh configreference.hh config.hh
  radiosettings.hh contact.hh rxgrouplist.hh channel.hh zone.hh scanlist.hh gpssystem.hh codeplug.hh
  roamingzone.hh roamingchannel.hh callsigndb.hh talkgroupdatabase.hh radioid.hh transferflags.hh
  encryptionextension.hh commercial_extension.hh smsextension.hh
  satellitedatabase.hh orbitalelementsdatabase.hh transponderdatabase.hh satelliteconfig.hh
  tyt_radio.hh tyt_interface.hh tyt_codeplug.hh tyt_callsigndb.hh tyt_extensions.hh
  md2017.hh md2017_codeplug.hh md2017_callsigndb.hh md2017_filereader.hh md2017_limits.hh
  md390.hh md390_codeplug.hh md390_filereader.hh md390_limits.hh
  uv390.hh uv390_codeplug.hh uv390_callsigndb.hh uv390_filereader.hh uv390_limits.hh
  dm1701.hh dm1701_codeplug.hh dm1701_callsigndb.hh dm1701_filereader.hh dm1701_limits.hh
  radioddity_radio.hh radioddity_codeplug.hh radioddity_extensions.hh radioddity_interface.hh
  rd5r.hh rd5r_codeplug.hh rd5r_filereader.hh rd5r_limits.hh
  gd77.hh gd77_codeplug.hh gd77_callsigndb.hh gd77_filereader.hh gd77_limits.hh
  opengd77_interface.hh opengd77base.hh opengd77base_codeplug.hh opengd77base_callsigndb.hh
  opengd77base_satelliteconfig.hh opengd77_extension.hh opengd77_limits.hh
  opengd77.hh opengd77_codeplug.hh opengd77_callsigndb.hh opengd77_satelliteconfig.hh
  openuv380.hh openuv380_codeplug.hh openuv380_callsigndb.hh openuv380_satelliteconfig.hh
  openrtx.hh openrtx_interface.hh openrtx_codeplug.hh
  c7000device.hh
  gd73.hh gd73_interface.hh gd73_codeplug.hh gd73_filereader.hh gd73_limits.hh
  anytone_interface.hh anytone_radio.hh anytone_codeplug.hh anytone_extension.hh anytone_limits.hh
  anytone_satelliteconfig.hh anytone_settingsextension.hh
  d868uv.hh d868uv_codeplug.hh d868uv_callsigndb.hh d868uv_limits.hh
  d878uv.hh d878uv_codeplug.hh d878uv_limits.hh
  d578uv.hh d578uv_codeplug.hh d578uv_limits.hh
  d878uv2.hh d878uv2_codeplug.hh d878uv2_limits.hh d878uv2_callsigndb.hh
  dmr6x2uv.hh dmr6x2uv_codeplug.hh dmr6x2uv_limits.hh
  dmr6x2uv2.hh dmr6x2uv2_codeplug.hh dmr6x2uv2_limits.hh
  auctus_a6_interface.hh
  dr1801uv.hh dr1801uv_interface.hh dr1801uv_codeplug.hh dr1801uv_filereader.hh dr1801uv_limits.hh)


set_target_properties(libdmrconf PROPERTIES
  MACOSX_RPATH TRUE
  OUTPUT_NAME dmrconf
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}")

target_link_libraries(libdmrconf PRIVATE Qt6::Core Qt6::SerialPort Qt6::Positioning Qt6::Network
  ${LIBUSB_1_LIBRARIES} ${YAMLCPP_LIBRARIES} ${ADDITIONAL_LIBS})

install(TARGETS libdmrconf DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}
        FILE_SET HEADERS DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libdmrconf/)

if (UNIX AND NOT APPLE AND ${INSTALL_UDEV_RULES})
  install(FILES "${CMAKE_SOURCE_DIR}/dist/99-qdmr.rules" DESTINATION ${INSTALL_UDEV_PATH})
endif(UNIX AND NOT APPLE AND ${INSTALL_UDEV_RULES})

=== src/CMakeLists.txt ===

qt6_add_resources(qdmr_RCC_SOURCES ../shared/resources.qrc)

qt6_add_executable(qdmr WIN32
  main.cc
  configitemwrapper.cc configitemwrapper.hh
  application.cc application.hh
  settings.cc settings.hh settingsdialog.ui
  dmrcontactdialog.cc dmrcontactdialog.hh dmrcontactdialog.ui
  dtmfcontactdialog.cc dtmfcontactdialog.hh dtmfcontactdialog.ui
  rxgrouplistdialog.cc rxgrouplistdialog.hh rxgrouplistdialog.ui
  analogchanneldialog.cc analogchanneldialog.hh analogchanneldialog.ui
  digitalchanneldialog.cc digitalchanneldialog.hh digitalchanneldialog.ui
  channelvalidator.cc channelvalidator.hh
  channelcombobox.cc channelcombobox.hh
  channelselectiondialog.cc channelselectiondialog.hh
  zonedialog.cc zonedialog.hh zonedialog.ui
  scanlistdialog.cc scanlistdialog.hh scanlistdialog.ui
  verifydialog.cc verifydialog.hh verifydialog.ui
  gpssystemdialog.cc gpssystemdialog.hh gpssystemdialog.ui
  contactselectiondialog.cc contactselectiondialog.hh
  searchpopup.cc searchpopup.hh
  aprssystemdialog.cc aprssystemdialog.hh aprssystemdialog.ui
  releasenotes.cc releasenotes.hh
  roamingzonedialog.cc roamingzonedialog.hh roamingzonedialog.ui
  roamingchannellistview.cc roamingchannellistview.hh roamingchannellistview.ui
  roamingchanneldialog.cc roamingchanneldialog.hh roamingchanneldialog.ui
  roamingchannelselectiondialog.cc roamingchannelselectiondialog.hh
  configobjectlistview.cc configobjectlistview.hh configobjectlistview.ui
  configobjecttableview.cc configobjecttableview.hh configobjecttableview.ui
  generalsettingsview.cc generalsettingsview.hh generalsettingsview.ui
  radioidlistview.cc radioidlistview.hh radioidlistview.ui
  contactlistview.cc contactlistview.hh contactlistview.ui
  grouplistsview.cc grouplistsview.hh grouplistsview.ui
  channellistview.cc channellistview.hh channellistview.ui
  zonelistview.cc zonelistview.hh zonelistview.ui
  scanlistsview.cc scanlistsview.hh scanlistsview.ui
  positioningsystemlistview.cc positioningsystemlistview.hh positioningsystemlistview.ui
  roamingzonelistview.cc roamingzonelistview.hh roamingzonelistview.ui
  collapsablewidget.cc collapsablewidget.hh
  extensionview.cc extensionview.hh extensionview.ui
  extensionwrapper.cc extensionwrapper.hh
  propertydelegate.cc propertydelegate.hh
  errormessageview.cc errormessageview.hh errormessageview.ui
  deviceselectiondialog.cc deviceselectiondialog.hh deviceselectiondialog.ui
  radioselectiondialog.cc radioselectiondialog.hh radioselectiondialog.ui
  dmriddialog.cc dmriddialog.hh dmriddialog.ui
  configobjecttypeselectiondialog.cc configobjecttypeselectiondialog.hh configobjecttypeselectiondialog.ui
  configmergedialog.cc configmergedialog.hh configmergedialog.ui
  satellitedatabasedialog.cc satellitedatabasedialog.hh satellitedatabasedialog.ui
  satelliteselectiondialog.cc satelliteselectiondialog.hh satelliteselectiondialog.ui
  repeaterdatabase.cc repeaterdatabase.hh
  repeatercompleter.cc repeatercompleter.hh
  repeaterbooksource.cc repeaterbooksource.hh
  repeatermapsource.cc repeatermapsource.hh
  hearhamrepeatersource.cc hearhamrepeatersource.hh
  radioidrepeatersource.cc radioidrepeatersource.hh
  selectivecallbox.cc selectivecallbox.hh
  transponderfrequencydelegate.cc transponderfrequencydelegate.hh
  mainwindow.cc mainwindow.hh mainwindow.ui
  ${qdmr_RCC_SOURCES})

#
# Translations
#
qt6_add_translations(qdmr TS_FILES
  ${PROJECT_SOURCE_DIR}/i18n/de.ts ${PROJECT_SOURCE_DIR}/i18n/en_US.ts
  ${PROJECT_SOURCE_DIR}/i18n/sv.ts ${PROJECT_SOURCE_DIR}/i18n/it.ts
  ${PROJECT_SOURCE_DIR}/i18n/nl.ts ${PROJECT_SOURCE_DIR}/i18n/pl.ts
  ${PROJECT_SOURCE_DIR}/i18n/fr.ts ${PROJECT_SOURCE_DIR}/i18n/pt_BR.ts)

#
# Icon generation
#
generate_icons(
  DIRECTORY ${CMAKE_SOURCE_DIR}/shared/icons
  ICONS application-qdmr
  THEMES light dark
  CONTEXT apps
  SIZES 16 32 48 64)

generate_icons(
  DIRECTORY ${CMAKE_SOURCE_DIR}/shared/icons
  ICONS application-exit application-settings
        device-read device-write-callsign device-write device-search device-write-satellites
        document-new document-open document-verify document-save-as document-download
        document-import document-export
        edit-move-10-down edit-move-10-up edit-move-down edit-move-up edit-move-bottom edit-move-top
        edit-satellites
        help-contents help-about
        symbol-minus symbol-plus symbol-none
  THEMES light dark
  CONTEXT actions
  SIZES 16 32)

generate_icons(
  DIRECTORY ${CMAKE_SOURCE_DIR}/shared/icons
  ICONS symbol-info symbol-warning symbol-error
  THEMES light dark
  CONTEXT emblems
  SIZES 16 32)

qt_add_resources(qdmr "icons"
  PREFIX "icons"
  BASE "${CMAKE_CURRENT_BINARY_DIR}/icons"
  FILES ${GENERATE_ICONS_OUTPUT_FILES})

qt_add_resources(qdmr "icons-themes"
  PREFIX "icons"
  BASE "${CMAKE_SOURCE_DIR}/shared/icons"
  FILES "${CMAKE_SOURCE_DIR}/shared/icons/light/index.theme"
        "${CMAKE_SOURCE_DIR}/shared/icons/dark/index.theme")


if (UNIX AND APPLE AND INSTALL_BUNDLE)
	set_target_properties(qdmr PROPERTIES
		MACOSX_BUNDLE ON
		MACOSX_BUNDLE_BUNDLE_NAME ${CMAKE_PROJECT_NAME}
		MACOSX_BUNDLE_BUNDLE_VERSION ${CMAKE_PROJECT_VERSION}
		MACOSX_BUNDLE_GUI_IDENTIFIER "de.darc.dm3mat.qdmr"
		MACOSX_BUNDLE_ICON_FILE "Resources/qdmr.icns"
		MACOSX_BUNDLE_LONG_VERSION_STRING ${CMAKE_PROJECT_VERSION}
		MACOSX_BUNDLE_SHORT_VERSION_STRING "${CMAKE_PROJECT_VERSION_MAJOR}.${CMAKE_PROJECT_VERSION_MINOR}"
    RESOURCE "${CMAKE_SOURCE_DIR}/dist/macosx/qdmr.icns" ${qdmr_QM_FILES})
endif(UNIX AND APPLE AND INSTALL_BUNDLE)

target_link_libraries(qdmr PRIVATE Qt6::Core Qt6::Widgets Qt6::Network Qt6::Positioning Qt6::UiTools
  ${LIBUSB_1_LIBS} libdmrconf)
target_include_directories(qdmr PUBLIC "${CMAKE_CURRENT_BINARY_DIR}")

# Install binary only if not a bundle under MacOS X
if (UNIX AND APPLE AND INSTALL_BUNDLE)
  install(TARGETS qdmr
    BUNDLE DESTINATION ${BUNDLE_PATH}/
    RESOURCE DESTINATION "${BUNDLE_PATH}/${CMAKE_PROJECT_NAME}.app/Contents/Resources")
else()
  install(TARGETS qdmr DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})
endif(UNIX AND APPLE AND INSTALL_BUNDLE)

=== test/CMakeLists.txt ===

qt_add_resources(TESTDATA resources.qrc)

qt_add_library(libdmrconfigtest STATIC libdmrconfigtest.cc libdmrconfigtest.hh ${TESTDATA})
target_link_libraries(libdmrconfigtest PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf ${ADDITIONAL_LIBS})


qt_add_executable(configtest configtest.cc configtest.hh ${TESTDATA})
target_link_libraries(configtest PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(tableformattest tableformattest.cc tableformattest.hh ${TESTDATA})
target_link_libraries(tableformattest PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(copytest copytest.cc copytest.hh ${TESTDATA})
target_link_libraries(copytest PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(labeltest labeltest.cc labeltest.hh ${TESTDATA})
target_link_libraries(labeltest PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(trafotest trafotest.cc trafotest.hh ${TESTDATA})
target_link_libraries(trafotest PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(crc32test crc32test.cc crc32test.hh ${TESTDATA})
target_link_libraries(crc32test PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(utilstest utilstest.cc utilstest.hh ${TESTDATA})
target_link_libraries(utilstest PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(chirptest chirptest.cc chirptest.hh ${TESTDATA})
target_link_libraries(chirptest PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(mergetest mergetest.cc mergetest.hh ${TESTDATA})
target_link_libraries(mergetest PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(smstemplatetest smstemplatetest.cc smstemplatetest.hh ${TESTDATA})
target_link_libraries(smstemplatetest PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})


# Unit tests for Radioddity devices
qt_add_executable(rd5r_test rd5r_test.cc rd5r_test.hh ${TESTDATA})
target_link_libraries(rd5r_test PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(gd73_test gd73_test.cc gd73_test.hh ${TESTDATA})
target_link_libraries(gd73_test PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(gd77_test gd77_test.cc gd77_test.hh ${TESTDATA})
target_link_libraries(gd77_test PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})


# Unit tests for OpenGD77 firmware
qt_add_executable(opengd77_test opengd77_test.cc opengd77_test.hh ${TESTDATA})
target_link_libraries(opengd77_test PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

# Unit tests for OpenGD77 firmware
qt_add_executable(openuv380_test openuv380_test.cc openuv380_test.hh ${TESTDATA})
target_link_libraries(openuv380_test PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})


# Unit tests for TyT devices
qt_add_executable(md390_test md390_test.cc md390_test.hh ${TESTDATA})
target_link_libraries(md390_test PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(uv390_test uv390_test.cc uv390_test.hh ${TESTDATA})
target_link_libraries(uv390_test PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(md2017_test md2017_test.cc md2017_test.hh ${TESTDATA})
target_link_libraries(md2017_test PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})


# Unit tests for AnyTone devices
qt_add_executable(d868uve_test d868uve_test.cc d868uve_test.hh ${TESTDATA})
target_link_libraries(d868uve_test PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(d878uv_test d878uv_test.cc d878uv_test.hh ${TESTDATA})
target_link_libraries(d878uv_test PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(d878uv2_test d878uv2_test.cc d878uv2_test.hh ${TESTDATA})
target_link_libraries(d878uv2_test PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(d578uv_test d578uv_test.cc d578uv_test.hh ${TESTDATA})
target_link_libraries(d578uv_test PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})


# Unit tests for Baofeng devices
qt_add_executable(dmr6x2uv_test dmr6x2uv_test.cc dmr6x2uv_test.hh ${TESTDATA})
target_link_libraries(dmr6x2uv_test PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(dmr6x2uv2_test dmr6x2uv2_test.cc dmr6x2uv2_test.hh ${TESTDATA})
target_link_libraries(dmr6x2uv2_test PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(dm1701_test dm1701_test.cc dm1701_test.hh ${TESTDATA})
target_link_libraries(dm1701_test PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})

qt_add_executable(dr1801_test dr1801_test.cc dr1801_test.hh ${TESTDATA})
target_link_libraries(dr1801_test PRIVATE Qt6::Core Qt6::Network Qt6::Positioning Qt6::SerialPort Qt6::Test ${YAMLCPP_LIBRARIES} libdmrconf libdmrconfigtest ${ADDITIONAL_LIBS})


add_test(NAME Config    COMMAND configtest)
add_test(NAME TableFormat COMMAND tableformattest)
add_test(NAME Copy      COMMAND copytest)
add_test(NAME Label     COMMAND labeltest)
add_test(NAME Transformations COMMAND trafotest)
add_test(NAME CRC32     COMMAND crc32test)
add_test(NAME Utils     COMMAND utilstest)
add_test(NAME CHIRP     COMMAND chirptest)
add_test(NAME Merge     COMMAND mergetest)
add_test(NAME SMSTemplates COMMAND smstemplatetest)

add_test(NAME RD5R      COMMAND rd5r_test)
add_test(NAME GD73      COMMAND gd73_test)
add_test(NAME GD77      COMMAND gd77_test)

add_test(NAME OpenGD77  COMMAND opengd77_test)
add_test(NAME OpenUV380 COMMAND openuv380_test)

add_test(NAME MD390     COMMAND md390_test)
add_test(NAME UV390     COMMAND uv390_test)
add_test(NAME MD2017    COMMAND md2017_test)

add_test(NAME D868UVE   COMMAND d868uve_test)
add_test(NAME D878UV    COMMAND d878uv_test)
add_test(NAME D878UV2   COMMAND d878uv2_test)
add_test(NAME D578UV    COMMAND d578uv_test)

add_test(NAME DMR6X2UV  COMMAND dmr6x2uv_test)
add_test(NAME DMR6X2UV2 COMMAND dmr6x2uv2_test)
add_test(NAME DM1701    COMMAND dm1701_test)
add_test(NAME DR1801    COMMAND dr1801_test)

=== doc/manual/Makefile ===
SRC = manual.xml $(shell find meta/ -name "*.*") $(shell find intro/ -name "*.*") $(shell find gui/ -name "*.*")\
      $(shell find codeplug/ -name "*.*") $(shell find conf/ -name "*.*") $(shell find reveng/ -name "*.*") $(shell find cli/ -name "*.*") 

all: images manual.pdf manual.epub html 

images:
	make -C intro/fig
	make -C gui/fig
	
	
manual.pdf: manual.fo
	fop -fo manual.fo -pdf manual.pdf
manual.fo: manual_combined.xml manual_fo.debian.xsl
	saxon-xslt -o manual.fo manual_combined.xml manual_fo.debian.xsl xslthl.config="/usr/share/xslthl/highlighters/xslthl-config.xml"
manual_combined.xml: $(SRC) 
	xmllint --nonet --noent --xinclude manual.xml > manual_combined.xml


manual.epub: images-epub manual_combined.xml 
	cp manual_combined.xml epub/manual.xml 
	make -C epub 
images-epub: images epub/fig
	install intro/fig/*.png epub/fig 
	install gui/fig/*.png epub/fig 
epub/fig:
	mkdir epub/fig 


html: images-html
	cp manual_combined.xml html/manual.xml 
	make -C html 
images-html: images html/fig manual_combined.xml
	install intro/fig/*.png html/fig 
	install gui/fig/*.png html/fig 
html/fig:
	mkdir html/fig


clean: 
	make -C intro/fig clean
	make -C epub clean
	make -C html clean
	rm -f manual.pdf manual.fo manual_combined.xml

=== doc/dmr-intro/fig/Makefile ===
FIGS = fm_duplex_a.tex fm_echolink_b.tex fm_simplex_b.tex simplex_privatecall.tex talkgroup_ex1c.tex trunk_net_ex2.tex trunk_net_ex4b.tex \
       fm_duplex_b.tex fm_echolink_c.tex repeater_local.tex simplex_allcall.tex talkgroup_ex1a.tex timeslot.tex trunk_net_ex3.tex \
       fm_echolink_a.tex fm_simplex_a.tex repeater_privatecall.tex simplex_groupcall.tex talkgroup_ex1b.tex trunk_net_ex1.tex trunk_net_ex4a.tex

=== doc/dmr-intro/script/Makefile ===

clean:
	rm *.aux *.idx *.ilg *.ind *.log *.out *.pdf *.synctex.gz *.toc

=== doc/manual/gui/fig/Makefile ===
all:

=== debian/changelog ===
qdmr (0.13.1-1) unstable; urgency=medium

  * Fixed build of man-pages.
  * Fixed install of header files.
  * Fixed build and loading of translations.

 -- Hannes Matuschek <dm3mat@darc.de>  Tue, 21 Oct 2025 14:06:15 +0200

qdmr (0.13.0-1) unstable; urgency=medium

  * Moved to QT6
  * Added support for OpenMD9600 and OpenMD2017
  * Add support for BTECH DMR-6x2 PRO
  * Add support for AnyTone D578UVIII (alias for D578UV)
  * Added offset frequency indicator for repeaters by @billbonney in #678
  * Theme updates when system switches to/from light/dark by @billbonney in #681
  * Reworked issue dialog to show tracebacks.
  * Updated OpenGD77 call-sign database implementation
  * Theme settings for OpenUV380
  * Fixed en/decoding of DTMF contact for OpenGD77
  * Set date time during programming of OpenGD77 devices
  * Finished encryption support
  * Implemented missing tot transmit timeout for opengd77 devices
  * Update DMR6X2 to FW Version 2.21
  * Fixed encoding of volume change prompt setting
  * Fixed en/decoding of backlight duration setting.
  * Fixed APRS PTT extension settings for AnyTone
  * Added 8.33kHz VFO tuning step for D878UV
  * Updated HW version strings for AnyTone devices.
  * Fixed channel type and power setting for GD73
  * Fixed squelch encoding for GD73.
  * Fix build on macOS by @cho-m in #671
  * Fix typo in udev rules by @AsciiWolf in #680
  * Add BUILD.md by @billbonney in #682
  * Do not hardcode screenshot size in AppStream metadata by @AsciiWolf in #683
  * Fix desktop file by @AsciiWolf in #685
  * Fixed RX/TX frequency for repeatermap.de sources.
  * Enforce DMR radio ID limit

 -- Hannes Matuschek <dm3mat@darc.de>  Mon, 20 Oct 2025 17:16:22 +0200

qdmr (0.12.3-1) unstable; urgency=medium

  * Fixed radiolimits prevent setting SelectedChannel as revert channel.
  * Fixed RT3S channel linking issues.
  * Fixed auto-completion swapping of RX/TX frequency for some sources.

 -- Hannes Matuschek <dm3mat@darc.de>  Sat, 31 May 2025 11:31:01 +0200

=== debian/control ===
Source: qdmr
Priority: optional
Maintainer: Hannes Matuschek <dm3mat@darc.de>
Build-Depends: debhelper-compat (=13), cmake, xsltproc, docbook-xsl, qt6-base-dev, qt6-tools-dev, qt6-tools-dev-tools, qt6-positioning-dev, qt6-serialport-dev, libusb-1.0-0-dev, libyaml-cpp-dev, librsvg2-bin
Standards-Version: 4.7.2
Section: hamradio
Vcs-Browser: https://salsa.debian.org/dm3mat/qdmr
Vcs-Git: https://salsa.debian.org/dm3mat/qdmr.git
Homepage: https://dm3mat.darc.de/qdmr

Package: libdmrconf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libdmrconf0 (= ${binary:Version}), ${misc:Depends}
Description: Header files for libdmrconf
 Libdmrconf is a Qt6 library to interface and program DMR radios. DMR is a
 digital modulation standard used in amateur and commercial radio. This library
 provides the core functionality to read, write, encode and decode binary 
 codeplugs for several radios, including AnyTone AT-D868UVE, AT-D878UV,
 AT-878UVII, AT-D578UV, TyT MD-390, MD-UV380, MD-UV390, MD-2017, Retevis RT8, 
 RT3S, RT82, Radioddity RD5R, GD-77, GD-73, Baofeng DMR-6X2 and radio running 
 the OpenGD77 firmware. This package contains the header files for libdrmconf.

Package: libdmrconf0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library to program DMR radios
 Libdmrconf is a Qt6 library to interface and program DMR radios. DMR is a
 digital modulation standard used in amateur and commercial radio. This library
 provides the core functionality to read, write, encode and decode binary 
 codeplugs for several radios, including AnyTone AT-D868UVE, AT-D878UV,
 AT-878UVII, AT-D578UV, TyT MD-390, MD-UV380, MD-UV390, MD-2017, Retevis RT8, 
 RT3S, RT82, Radioddity RD5R, GD-77, GD-73, Baofeng DMR-6X2 and radio running 
 the OpenGD77 firmware.

Package: qdmr
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GUI application to program DMR radios
 qdmr is a Qt6 application to program DMR radios. DMR is a digital modulation
 standard used in amateur and commercial radio. To this end, qdmr is an 
 alternative codeplug programming software (CPS) that supports several radios 
 of several manufacturers. Including AnyTone AT-D868UVE, AT-D878UV, AT-878UVII, 
 AT-D578UV, TyT MD-390, MD-UV380, MD-UV390, MD-2017, Retevis RT8, RT3S, RT82, 
 Radioddity RD5R, GD-77, GD-73, Baofeng DMR-6X2 and radio running the OpenGD77 
 firmware.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_MAN=ON -DDOCBOOK2MAN_XSLT=docbook_man.debian.xsl -DINSTALL_UDEV_RULES=OFF

=== debian/watch ===
version=4
opts="dversionmangle=s/\+git.*//" \
https://github.com/hmatuschek/qdmr/tags .*/archive/refs/tags/v?(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## qdmr 0.13.2

=== debian/changelog ===
qdmr (0.13.2-1) unstable; urgency=medium

  * Fixed crash when adding new channels.
  * Fixed out-of-bounds write when encoding call-sign DB.
  * Update and clean-up of AT-D587UV codeplug.
  * Fix encoding of back-light duration for all AnyTone like devices.
  * Fixed handling of modified signal.
  * Implemented filtering/sorting of all tables.
  * Update D578UV to add missing key functions.
  * Fix D578 issues with display colours.
  * Fixed call-sign DB for OpenUV380 etc.
  * Speed up startup.
  * Implemented hack to prevent crash of OpenGD77 FW.
  * Update frequency input matching.
  * Fixed spelling.
  * Completed Italian translation.

 -- Hannes Matuschek <dm3mat@darc.de>  Sun, 30 Nov 2025 21:50:04 +0100

## qdmr 0.13.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.20.0)
-project(qdmr VERSION 0.13.1)
+project(qdmr VERSION 0.13.3)
 
 set(RELEASE_SUFFIX "")
 
@@ -31,7 +31,8 @@
 include(GNUInstallDirs)
 include(GenerateIcons)
 
-find_package(Qt6 REQUIRED COMPONENTS Core Widgets UiTools Network SerialPort Positioning LinguistTools)
+find_package(Qt6 REQUIRED COMPONENTS Core Widgets UiTools Network SerialPort Positioning
+  Concurrent LinguistTools)
 qt6_standard_project_setup()
 
 find_package(LIBUSB_1 REQUIRED)

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -93,6 +93,7 @@
   SOVERSION "${PROJECT_VERSION_MAJOR}")
 
 target_link_libraries(libdmrconf PRIVATE Qt6::Core Qt6::SerialPort Qt6::Positioning Qt6::Network
+  Qt6::Concurrent
   ${LIBUSB_1_LIBRARIES} ${YAMLCPP_LIBRARIES} ${ADDITIONAL_LIBS})
 
 install(TARGETS libdmrconf DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -86,7 +86,7 @@
         document-new document-open document-verify document-save-as document-download
         document-import document-export
         edit-move-10-down edit-move-10-up edit-move-down edit-move-up edit-move-bottom edit-move-top
-        edit-satellites
+        edit-satellites edit-clear item-filter
         help-contents help-about
         symbol-minus symbol-plus symbol-none
   THEMES light dark
@@ -125,7 +125,7 @@
 endif(UNIX AND APPLE AND INSTALL_BUNDLE)
 
 target_link_libraries(qdmr PRIVATE Qt6::Core Qt6::Widgets Qt6::Network Qt6::Positioning Qt6::UiTools
-  ${LIBUSB_1_LIBS} libdmrconf)
+  Qt6::Concurrent ${LIBUSB_1_LIBS} libdmrconf)
 target_include_directories(qdmr PUBLIC "${CMAKE_CURRENT_BINARY_DIR}")
 
 # Install binary only if not a bundle under MacOS X

=== debian/changelog ===
qdmr (0.13.3-1) unstable; urgency=medium

  * Reworked parallel parsing of databases.
  * Fixed decoding issue of AES keys for AnyTone devices.
  * Fixed misleading error message by @Kalle4tw.
  * Update the Flatpak by @AsciiWolf.
  * Implemented mapping of ranges.
  * Fixed missing encoding of GPS toggle for D878UV.
  * Update translations.

 -- Hannes Matuschek <dm3mat@darc.de>  Mon, 19 Jan 2026 21:00:00 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Hannes Matuschek <dm3mat@darc.de>
 Build-Depends: debhelper-compat (=13), cmake, xsltproc, docbook-xsl, qt6-base-dev, qt6-tools-dev, qt6-tools-dev-tools, qt6-positioning-dev, qt6-serialport-dev, libusb-1.0-0-dev, libyaml-cpp-dev, librsvg2-bin
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Section: hamradio
 Vcs-Browser: https://salsa.debian.org/dm3mat/qdmr
 Vcs-Git: https://salsa.debian.org/dm3mat/qdmr.git
